<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Base_table {

	public $CI;
	public $tbl;
	public $tbl_key;
	public $cur_time;
	public $user_id;
	public $entity_id;
	
	function __construct ($params)
	{
		$this->CI =& get_instance();
		
		$this->tbl_key	= $params['tbl_key'];
		$this->tbl		= $params['tbl'];
		$this->user_id	= $this->CI->ot_user->get('user_id');
		$this->entity_id= $this->CI->ot_app->get('entity_id');
		
		$this->CI->load->library('Auth');
        $this->cur_time = $this->CI->auth->get_timezone_date('','UTC');
	}

	// update table	
	function save(&$data, $params= array())
	{
		$this->CI->load->database();

		if ($data)
		{
			// table store access direct
			if (!empty($data["tbl_key"]) && !empty($data["tbl"]))
			{
				$this->tbl_key 	= $data["tbl_key"];
				$this->tbl 		= $data["tbl"];
			} else {
				$this->formatdata($data);
			}
			
			// entity_id
			if ($this->entity_id) {
				$data['entity_id']	= $this->entity_id;
				
				// set created | last updated details
				if (!empty($data[$this->tbl_key]))
				{
					$data['last_updated_by']	= $this->user_id;
					$data['last_updated_date']	= $this->cur_time;
				}
				else
				{
					$data['created_by']		= $this->user_id;
					$data['created_date']	= $this->cur_time;
				}
			}
			// get fields of from table
			$fields = $this->CI->db->list_fields($this->tbl);

			// Get value of primary id
			$id = (!empty($data[$this->tbl_key]))?$data[$this->tbl_key]:0;

	
			// get data from database
			if ($id)
			{
				$this->CI->db->select($this->tbl_key);
				$query = $this->CI->db->get_where($this->tbl, array($this->tbl_key=>$id));
	
				$row = $query->num_rows();
			}

			if (!$this->check($data)) {
				return false;
			}
			// check posted data is in fields
			foreach ($data as $field => $value)
			{
				if (@!in_array($field, $fields))
				{
					unset($data[$field]);
				}
			}

			// insert
			if (empty($row))
			{
				$this->CI->db->insert($this->tbl, $data);
				return ($id)?$id:$this->CI->db->insert_id();
			}
			// update
			else
			{
				if (isset($params['where']) && $params['where'])
				{
					$where = $params['where'];	
				}
				$where[$this->tbl_key] = $id;
				if (!empty($data['entity_id'])) {
						$where['entity_id']	= $data['entity_id'];
				}
				$this->CI->db->where($where);
				
				if (isset($params['where_str']) && $params['where_str']) {
					$this->CI->db->where($params['where_str']);
				}
				$values = $data;
				unset($values[$this->tbl_key]);
				$this->CI->db->update($this->tbl, $values);
				unset($values);
//				return $this->CI->db->affected_rows()?$id:false;
				return $id;
			}
		}
	}

	function check($data) {
		return true;
	}

	function formatdata ($data) {
		return true;
	}
	
	function check_duplicate($data, $where)
	{
		$where[$this->tbl_key.' != '] = $data[$this->tbl_key];		
		$this->CI->db->select('count(*) as duplicate_count');
		$this->CI->db->from($this->tbl);
		$this->CI->db->where($where);
		
		$query = $this->CI->db->get();
		$result = $query->row();
		
		return $result->duplicate_count;
	}
}
