<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(FCPATH . '/application/libraries/base_table.php');

class Entity_setting_table extends Base_table {

	function __construct()
	{
		parent::__construct(array('tbl'=>'entity_setting', 'tbl_key'=>'entity_setting_id'));
	}

	public function save($data)
	{
		return parent::save($data);
	}

	public function store_default_data ($data)
	{
		$this->CI->load->database();
		
		
		if (empty($data['entity_id'])) {
			return false;
		}
		
		$dynamic_data  = array(
						'entity_id' 		=> $data['entity_id'],
						'account_owner_id'	=> $data['user_id'],
						'created_by'		=> isset($data['created_by'])?$data['created_by']:$data['user_id']
					);

		$static_data = array(
							array(
								'time_zone_code' 		=> 	'UTC',
								'fiscal_year_month'		=> 	1,
								'non_working_days'		=> 'SA,SU',
								'start_week_on'			=> 'MO',
								'skip_daysoff'			=> 	TRUE,
								'date_format'			=> 'yyyy-MM-dd',
								'time_format'			=> 	FALSE,
								'period_format'			=>	0,
								'time_stamp_req'		=> 	0,
								'modify_billable'		=>  1,
								'time_sheet_approval'	=> 	0,
								'time_round_to'			=> 'H',
								'currency_code'			=> 'USD',
								'number_format'			=> 'N',
								'theme'					=> 	'',
								'language'				=> 'EN',
								'created_date'			=> isset($data['register_date'])?$data['register_date']:$this->CI->auth->get_timezone_date(),
								'hours_per_day'			=> 8
							)
						);
						
		$values = array();
		
		foreach ($static_data as $val) {
			$values[] = array_merge($val,$dynamic_data);
		}
		
		return $this->CI->db->insert_batch($this->tbl, $values); 
	}
}
/* end of Entity_setting_table.php */
