<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Comments_member extends CI_Model
{
	function __construct()
	{
		parent::__construct();
		$this->load->library(OTBASE_PATH.'OT_App');
        $this->load->library(OTBASE_PATH.'OT_User');
        $this->load->library('Auth');
		$this->cur_time = $this->auth->get_timezone_date();
		$this->load->model('attachment');
	}
	
	// Magic function return false
	public function __call($name, $arguments)
    {
       return array();
    }

	public function comments_list_query($select, $options = array())
	{
		$query = '';
		if(!empty($options['filter'])) {
			switch($options['filter']) {
				case 'both':
					$limit = '';
					if (!empty($options['count'])) 	{
						$from = !empty($options['from'])?$options['from']:0;
						$limit = " LIMIT " . $from . "," . $options['count'];
					}
					
					unset($options['from']);
					unset($options['count']);
					unset($options['order_by_direction']);
					unset($options['order_by']);
										
					$comments_query = $this->get_comments_query($select.', 0 as a_mode, 1 as is_comment', $options); 
					$user_activity_query = $this->get_activity_query($select, $options);

					$activity_query = explode('FROM (',$user_activity_query);
					$pos = stripos($activity_query[1], ')');
					if($pos !== false){
				        $activity_query[1] = substr_replace($activity_query[1], "", $pos, 1);
				    }
					$activity_query = $activity_query[0] . " FROM " .  $activity_query[1];
					$query = "SELECT c.* FROM((" . $comments_query . ") UNION (" .  $activity_query . ")) AS c ORDER BY c.created_date DESC " . $limit;
				break;
				case 'comments':
					$options['order_by']	= !empty($options['order_by']) ? $options['order_by'] : 'cm.created_date';
					$options['order_by_direction'] = !empty($options['order_by_direction']) ? $options['order_by_direction'] : 'desc';
					$query = $this->get_comments_query($select.', 1 as is_comment', $options);
				break;		
				case 'activity':
					$options['order_by']	= !empty($options['order_by']) ? $options['order_by'] : 'user_activity_id';
					$options['order_by_direction'] = !empty($options['order_by_direction']) ? $options['order_by_direction'] : 'desc';
					$query = $this->get_activity_query($select, $options);
				break;	
			}	
		}
//echo $query;
		return $query; 

		
	}
	
	public function get_comments_query($select, $options = array()) 
	{
		// Prepare Comments Query
		$this->db->from('comments as cm');
		$this->db->join('entity_users as u', 'cm.entity_id=u.entity_id and u.user_id=cm.created_by', 'INNER');

		$where	= array('cm.entity_id' => $this->ot_app->get('entity_id'),'cm.parent_comment_id'=>'0');

		if(!empty($options['module_type']))
		{
			$where['cm.module_type']	= $options['module_type'];

			if(!empty($options['module_id']))
				$where['cm.module_id']	= $options['module_id'];
		}

		if (!empty($options['comment_id']))
		{
			$where['comment_id']	= $options['comment_id'];
		}

		$this->db->select($select, false);
		$this->db->where($where);

		if(!empty($options['order_by'])) 
		{	
			$order_by 			= !empty($options['order_by']) ? $options['order_by'] : '';
			$order_by_direction = !empty($options['order_by_direction']) ? $options['order_by_direction'] : '';
			$this->db->order_by($order_by, $order_by_direction);
		}
		
		$from = !empty($options['from'])?$options['from']:0;
		if (!empty($options['count']))
		{
			$this->db->limit($options['count'], $from);
		}

		$this->db->get();
		$comments_query = $this->db->last_query();
		
		return $comments_query;
	}
	
	public function get_activity_query($select, $options = array())
	{
		// Prepare User Activity query
		$this->db->select('ua.user_activity_id as comment_id, -1 as parent_comment_id, 0 as reply_count, SUBSTRING(ua.a_mode,1,1) as module_type, ua.a_id as module_id, ua.a_notes as message, 0 as attachments, ua.user_id as created_by,  ua.a_date as created_date, u.first_name, u.last_name, u.user_image, ua.a_mode as a_mode, 0 as is_comment ', FALSE);
		$this->db->from('user_activity as ua');
		$this->db->join('entity_users as u', 'ua.entity_id=u.entity_id and u.user_id=ua.user_id', 'INNER');
		$this->db->where(array('ua.entity_id' => $this->ot_app->get('entity_id')));
		$where = '';
		if(!empty($options['module_type']))
		{
			$module_types = explode(",", $options['module_type']);
			for($i=0; $i<count($module_types);$i++)
			$where.= ' ua.a_mode like "' . $module_types[$i] . '%" OR ';
			$pos = strrpos($where, "OR");
			if ($pos !== false)
			$where = "(". substr_replace($where, ")", $pos, strlen("OR"));
			$this->db->where($where);
		}

		if(!empty($options['module_id']))
			$this->db->where('ua.a_id' , $options['module_id']);
		
		if(!empty($options['user_id'])) {
			$this->db->select('u.user_image as user_image_path', false);
			$this->db->where('ua.user_id' , $options['user_id']);
		}	
			
		if(!empty($options['order_by'])) 
		{
			$order_by 			= !empty($options['order_by']) ? $options['order_by'] : '';
			$order_by_direction = !empty($options['order_by_direction']) ? $options['order_by_direction'] : '';
			$this->db->order_by($order_by, $order_by_direction);
		}		
		
		$from = !empty($options['from'])?$options['from']:0;
		if (!empty($options['count']))
		{
			$this->db->limit($options['count'], $from);
		}
		
	
		$this->db->get();
		$user_activity_query = $this->db->last_query();
		
		return $user_activity_query;
	}

	public function get_comments($select='cm.comment_id, cm.parent_comment_id, cm.reply_count, cm.module_type, cm.module_id, cm.message, cm.created_by, cm.created_date, u.first_name, u.last_name, u.user_image', $options = array())
	{ // echo("in");//exit;
		if (empty($options))
		{
			$options	= array_merge($options, $this->options);
		}

		$query = $this->db->query($this->comments_list_query($select, $options));

		$result['items'] = $query->result_array();
		
		if ($result['items'])
		{
			$comment_attach = $comment_ids = array();
			foreach($result['items'] as $key=>$value) 
			{
				$result['items'][$key]['message'] = htmlspecialchars($result['items'][$key]['message']);
				// separate comment ids
				if($value['parent_comment_id']==0) {
					$comment_ids[] = $value['comment_id'];
					if ($value['attachments']) {
						$comment_attach[]=$value['comment_id'];
					}
				}
			}
			
			if ($comment_attach) {
				// get attachements based on comment ids
				$result['attachments'] = $this->get_attachment_details($comment_attach, 'C');
			}
		}

		if (!empty($options['module_type'])) {
			switch ($options['module_type']) {
				case 'T':
					$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'task_id' => $options['module_id'], 'user_id' => $this->ot_user->get('user_id')));
					$this->db->update('project_task_users', array('new_comments' => 0));
				break;
				case 'P':
					$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'project_id' => $options['module_id'], 'user_id' => $this->ot_user->get('user_id')));
					$this->db->update('project_users', array('new_comments' => 0));
				break;
			}
		}

		return $result;
	}
	
	public function get_attachment_details($ids, $module_type)
	{
		$this->db->select('at.attachment_id, at.file_path, at.file_name, at.title, at.file_type, at.module_id');
		$this->db->from('attachment as at');
		$this->db->join('comments cm', 'at.entity_id=cm.entity_id and at.module_id = cm.comment_id');
		$this->db->join('entity_users as u', 'cm.entity_id=u.entity_id and u.user_id = cm.created_by', 'INNER');
		$where = array('at.entity_id' => $this->ot_app->get('entity_id'), 'at.module_type' => 'C');
		if (is_array($ids))
			$this->db->where_in('at.module_id', $ids);
		else
			$where['at.module_id'] = $ids;
		$this->db->where($where);
		
		$reply_query  = $this->db->get();
      	$result = $reply_query->result_array();
      	
      	foreach($result as $key=>$val) {
      		$result[$key]['encrypt_key'] = base64_encode($val['attachment_id'].'-'.$this->session->userdata('session_id')); 
      	}
      	return $result;
	}
	
	public function get_reply_comments($select,$comment_id, $options, $all_comments = false)
	{
		//echo $comment_id;
		$this->db->select($select,false);
		$this->db->from('comments cm1');
		$this->db->join('comments cm2', 'cm1.entity_id=cm2.entity_id and cm1.comment_id = cm2.parent_comment_id', 'LEFT OUTER');
		$this->db->join('entity_users as u', 'cm2.entity_id=u.entity_id and u.user_id = cm2.created_by', 'INNER');
		$this->db->where(array('cm2.parent_comment_id >'=>0, 'cm1.comment_id'=>$comment_id, 'cm1.entity_id' => $this->ot_app->get('entity_id')));
		$this->db->order_by('cm1.comment_id, cm2.created_date','asc');
			
		if(!$all_comments) {
			$this->db->where('(cm2.created_date <= curdate() and cm2.created_date >= DATE_ADD(CURDATE(), INTERVAL -1 DAY))', null, TRUE);
		}	
		
		if(!empty($options['module_type']))
			$this->db->where('cm1.module_type' , $options['module_type']);

		if(!empty($options['module_id']))
			$this->db->where('cm1.module_id' , $options['module_id']);
			
      	$reply_query  = $this->db->get();
      	$result = $reply_query->result_array();

      	foreach($result as $key=>$value) 
		{
      		if(is_admin())
				$result[$key]['delete_permission'] = true;
			else	
				$result[$key]['delete_permission'] = $this->get_comment_delete_permission($value);
		}
     	return $result;
	}
	
	public function get_comment_delete_permission($data)
	{
		if(is_pm() || is_pmf()) {
			if($data['module_type']=='P')
				if($this->get_project_users_count($data['module_id'])>0)
					return true;
		}
		if(is_member()) {
			if($data['created_by'] == $this->ot_user->get('user_id'))
				return true;
		}
		return false;
	}
	public function get_project_users_count($project_id)
	{
		$this->db->select('count(*) as total');
		$this->db->from('project as pr');
		$this->db->join('project_users as pru', 'pr.entity_id=pru.entity_id and pr.project_id=pru.project_id', 'INNER');
		$this->db->where(array('pr.entity_id' => $this->ot_app->get('entity_id'), 'pru.user_id'=>$this->ot_user->get('user_id'), 'pr.project_id' => $project_id));
		
		$query = $this->db->get();
		$result = $query->row_array();
		return (!empty($result['total'])?$result['total']:0);
	}
	
	public function get_total_reply_comments($comment_id, $options)
	{
		$this->db->select('count(*) as total_count');
		$this->db->from('comments');
		$this->db->where(array('entity_id'=>$this->ot_app->get('entity_id'), 'module_id'=>$options['module_id'], 'module_type'=>$options['module_type']));
		$reply_query  = $this->db->get();
      	$result = $reply_query->row_array();
      	
     	return isset($result['total_count'])?$result['total_count']:0;
	}
	
	public function save_comments($data, $reply = false)
	{
		$this->load->library('comments_table');
		$this->load->library('attachment_table');
		
		$data['entity_id']		= $this->ot_app->get('entity_id');
		$data['created_by']		= $this->ot_user->get('user_id');
		$data['created_date']	= $this->cur_time;
		$data['module_type']	= !empty($data['module_type']) ? $data['module_type'] : 'P';
		$data['attachments']	= empty($data['attachments']) ? 0 : 1;

		$result	= $this->comments_table->save($data);

		if($result)
		{
			$id = $result['comment_id'];
			
			switch($data['module_type']) {
				case 'T':
						$this->db->where(array('entity_id' => $data['entity_id'], 'task_id'=>$data['module_id']));
						$this->db->update('project_task', array('has_comments'=>1));

//						if (empty($data['parent_comment_id'])) {
							$this->db->where(array('entity_id' => $data['entity_id'], 'task_id'=>$data['module_id'], 'user_id !=' => $data['created_by']));
							$this->db->set('new_comments', '`new_comments`+ 1', FALSE);
							$this->db->update('project_task_users');
//						}
					break;
				case 'P':
//						if (empty($data['parent_comment_id'])) {
							$this->db->where(array('entity_id' => $data['entity_id'], 'project_id'=>$data['module_id'], 'user_id !=' => $data['created_by']));
							$this->db->set('new_comments', '`new_comments`+ 1', FALSE);
							$this->db->update('project_users');
//						}
					break;
			}

			if(!empty($data['attachment_details'])) 
			{
				$attachment_id	= array();
	        	foreach ($data['attachment_details'] as $key=>$val)
	        	{
	        		$attachment_data = $val;//$data['attachment_details'];
	        		$attachment_data['module_type']	= 'C';
	        		$attachment_data['module_id']	= $id;

	        		$attachment_id[$attachment_data['uid']]	= $this->attachment_table->save($attachment_data);
	        	}

				$result['attachment_id'] = $attachment_id;
			}
		}
		else
			return false;
 	
		if($reply) {
			$this->update_reply_count($data['parent_comment_id']);
		}

		return $result;
	}
	public function update_reply_count($comment_id)
	{
		$this->db->select('count(*) as reply_count');
		$this->db->from('comments');
		$this->db->where(array('parent_comment_id'=>$comment_id, 'entity_id' => $this->ot_app->get('entity_id')));
		
		$reply_query  = $this->db->get();
      	$reply_result = $reply_query->row_array();
		$reply_count = ($reply_result['reply_count'])?$reply_result['reply_count']:0;
		
		$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'comment_id' => $comment_id));
		return $this->db->update('comments', array('reply_count'=>$reply_count));
		
	}
    
	public function delete_comments($comment_id, $reply_comments = false) 
	{
		$data = $this->input->post();
		// check reply posted by others
		$this->db->select('comment_id,parent_comment_id')->from('comments');
		if (!$reply_comments) {
			$this->db->where(array('entity_id'=>$this->ot_app->get('entity_id'), 'parent_comment_id' => $comment_id, 'created_by !=' => $this->ot_user->get('user_id')));
			$query = $this->db->get();
			$result = $query->row();
			if ($result)
			{
				return false;
			}
		} else {
			$this->db->where(array('entity_id'=>$this->ot_app->get('entity_id'), 'comment_id' => $comment_id, 'created_by' => $this->ot_user->get('user_id')));
			$query = $this->db->get();
			$row = $query->row();
			if (!$row) {
				return false;
			}
			$parent_comment_id = $row->parent_comment_id;
		}
		$this->db->where(array('entity_id'=>$this->ot_app->get('entity_id')));
		
		if(!empty($data['module_type']))
			$this->db->where('module_type', $data['module_type']);
			
		if(!empty($data['module_id']))
			$this->db->where('module_id', $data['module_id']);
				
		$this->db->where('created_by', $this->ot_user->get('user_id'));
		if(!$reply_comments)
		{
			$this->db->where(' (comment_id = ' . $comment_id . ' OR parent_comment_id = '.$comment_id.')', NULL, FALSE);
			if($this->db->delete('comments'))
			{
				$options = array('module_id'=>$comment_id, 'module_type'=>'C');
				$this->attachment->delete_attachment($options);

				if ($data['module_type'] == 'T')
				{
					$cnt	= $this->db->select('count(comment_id) AS comment_count')->from('comments')->where(array(
						'module_type'	=> $data['module_type'],
						'module_id'		=> $data['module_id']
					))->get()->row_array();

					if (empty($cnt) || empty($cnt['comment_count']))
					{
						$this->db->where(array(
							'entity_id'	=> $this->ot_app->get('entity_id'),
							'task_id'	=> $data['module_id']
						));
						$this->db->update('project_task', array('has_comments' => 0));
					}
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		else {
			$this->db->where('comment_id', $comment_id);
			if($this->db->delete('comments')) { 
				return $parent_comment_id?$this->update_reply_count($parent_comment_id):true;
			}	
			else
				return false;
		}
	}

	public function remove_notify($project_id)
	{
		$this->db->where('entity_id', $this->entity_id);
		$this->db->where('user_id', $this->user_id);
		$this->db->where('project_id', $project_id);
		// Delete all comment related notification records.
		$this->db->where('type', 'CO');
		$this->db->delete('notification');
	}
}
