<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(APPPATH . '/models/expenses/mod.expenses_member.php');

class Expenses_pm extends Expenses_member {

	private $_user_id	= 0;

	function __construct()
	{
		parent::__construct();
		$this->_user_id	= $this->ot_user->get('user_id');
	}

	public function get_expenses($select='', $options=array()) 
	{
		$select	= empty($select) ? 'ex.expense_id, ex.project_id, ex.amount, ex.created_by, DATE_FORMAT(ex.expense_date, "%Y-%m-%d") as expense_date, ex.notes, ex.expense_type_id, ex.approved_by, ex.invoice_id, ex.quantity, ex.unit_price, pr.project_id, pr.project_name, pr.project_code,  u.first_name, u.user_image, ext.name, ext.units' : $select;
		if (empty($options))
		{
			$options	= array_merge($options, $this->options);
		}

		$options['role_filter']	= ' ((pru.user_role="M" and  ex.created_by=' . $this->_user_id . ') or (pru.user_role!="M" and ex.approved_by>0))';

		$query	= $this->expenses_list_query($select, $options);

		$result	= $query->result_array();

		foreach($result as $key=>$res)
		{
			$result[$key]['edit_permission']	= 0;
			if($res['created_by'] == $this->_user_id)
			{
				$result[$key]['edit_permission']	= 1;
			}

// 			$result[$key]['edit_permission'] 		= 1;
// 			$result[$key]['proj_edit_permission'] 	= 0;
// 			if($res['created_by'] == $this->_user_id)
// 			{
// 				$result[$key]['proj_edit_permission'] 	= 1;
// 			}
		}

		return $result;
	}

	public function get_approve_expenses($select='', $options=array()) 
	{
		$select	= empty($select) ? 'ex.expense_id, ex.project_id, ex.amount, ex.expense_date, ex.notes, ex.expense_type_id, ex.approved_by, ex.invoice_id, ex.quantity, ex.unit_price, pr.project_name, pr.project_code,  u.first_name, u.user_image, ext.name, ext.units' : $select;
		if (empty($options))
		{
			$options	= array_merge($options, $this->options);
		}

		$options['role_filter'] = '(pru.user_role!="M" and ex.approved_by=0)';
		
		$query = $this->expenses_list_query($select, $options);
		return $query->result_array();
	}
	
	public function save ($data)
	{
		$this->load->library('expense_table');
		$data['approved_by'] = $this->ot_user->get('user_id');
		return $this->expense_table->save($data);		
	}
	
	public function approve($data)
	{
		$update_data['approved_by'] 		= $this->ot_user->get('user_id');
		$update_data['last_updated_by']		= $this->ot_user->get('user_id');
		$update_data['last_updated_date'] 	= $this->auth->get_timezone_date();

//		if(!empty($data['project_id']) && $data['project_id']>0)
//			$this->db->where('project_id',$data['project_id']);			
				
		if(!empty($data['expense_id']) && $data['expense_id']>0)
			$this->db->where('expense_id',$data['expense_id']);				
		
		$this->db->where(array('approved_by'=>0,'entity_id'=>$this->ot_app->get('entity_id')));
		return $this->db->update('project_expense', $update_data);

	}

	public function get_users()
	{
		$this->db->select('u.user_id,u.first_name,u.last_name,u.is_active');
		$this->db->from('project pr');
		$this->db->join('project_users pru', 'pr.entity_id=pru.entity_id and pr.project_id = pru.project_id','INNER');
		$this->db->join('entity_users u', 'u.user_id = pru.user_id','INNER');
		$this->db->where('pr.entity_id', $this->ot_app->get('entity_id'));
		$this->db->where('u.is_active', '1');
		$this->db->group_by('pru.user_id');
		$this->db->order_by('u.first_name,u.last_name');
	
		$query = $this->db->get();
		$result = $query->result_array();
		return $result;
	}

	public function get_clients()
	{
		$this->db->select('c.client_id, c.client_code, c.client_name, c.is_active');
		$this->db->from('client as c');
		$this->db->where('c.entity_id', $this->ot_app->get('entity_id'));
		$this->db->where('c.is_active', '1');
		$this->db->order_by('c.client_name');

		$query	= $this->db->get();
		$result	= $query->result_array();

		return $result;
	}
}
