<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(APPPATH . '/models/projects/mod.projects_pmf.php');

class Projects_admin extends Projects_pmf
{
	public	$options	= array();

	function __construct()
	{
		parent::__construct();
	}

	// return projects list query
	public function projects_list_query($select, $options = array())
	{
		
		$this->db->select($select.", 'A' as user_role", false);
		$this->db->from('project as pr');
		$this->db->join('client as cl', 'pr.entity_id=cl.entity_id and pr.client_id = cl.client_id', 'INNER');
		$where = array();

		if (!empty($options['filters']))
		{
			foreach($options['filters'] as $key=>$val) {
				if (is_array($val))
					$this->db->where_in($key,$val);
				else
					$where[$key] = $val;
			}
		}
		$where	= array_merge($where, array('pr.entity_id' => $this->ot_app->get('entity_id')));
		
		$this->db->where($where);

		$order_by 			= !empty($options['order_by']) ? $options['order_by'] : 'pr.project_name';
		$order_by_direction = !empty($options['order_by_direction']) ? $options['order_by_direction'] : 'asc';

		$this->db->order_by($order_by, $order_by_direction);

		$from	= !empty($options['from']) ? $options['from'] : 0;
		if (!empty($options['count']))
		{
			$this->db->limit($options['count'], $from);
		}
		return $this->db->get();
	}

	// return projects in as array of standard array indexes
	public function get_projects($select = '', $options = array())
	{
		if (empty($options))
		{
			$options	= array_merge($options, $this->options);
		}
		$select=($select)?$select:'pr.project_id, cl.client_id, concat(pr.project_code, pr.project_name) AS project_name, pr.budget_value,CASE WHEN pr.invoice_type="A" THEN (pr.hourly_rate*pr.actual_value) ELSE pr.actual_value END AS actual_value, pr.budget_type, pr.members_count,pr.is_active,pr.uninvoiced_hours, pr.bg_color, pr.invoice_type, pr.created_by';
		$query = $this->projects_list_query($select, $options);

		return $query->result_array();
/*		if ($projects && isset($projects[0]['budget_type'])) {
			$result = $pro_ids = array();
			foreach ($projects as $pro) {
				$result[$pro['project_id']] = $pro;
				switch ($pro['budget_type'])
				{
					case 'AT':
							$pro_ids['PTY'][] = $pro['project_id'];
						break;
					case 'AP':
							$pro_ids['PRU'][] = $pro['project_id'];
						break;
				}
			}

			if ($pro_ids) {
				foreach ($pro_ids as $key => $pro) {
					if ($key=='PTY') {
						$this->db->select('project_id, sum(actual_hours*hourly_rate) AS actual_value');
						$this->db->from('project_task_types');
					} else {
						$this->db->select('project_id, sum(actual_hours*hourly_rate) AS actual_value');
						$this->db->from('project_users');
					}
					$this->db->where_in('project_id', $pro);
					$ac_values = $this->db->get()->result_array();

					if ($ac_values) {
						foreach($ac_values as $akey => $aval) {
							$result[$aval['project_id']]['actual_value'] = $aval['actual_value'];
						}
					}
				}
			}
		}
		return $result;*/
	}

	public function get_project_count()
	{
		$this->db->select('SUM(is_active=1) AS active_count,SUM(is_active=0) AS archive_count', false);
		$this->db->from('project');
		$this->db->where(array('entity_id' => $this->ot_app->get('entity_id')));
		$query = $this->db->get();

		$result = $query->row_array();
		return $result;
	}
}
