<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(APPPATH . '/models/users/mod.users_pmf.php');

class Users_admin extends Users_pmf {

	function __construct()
	{
		parent::__construct();
	}
	
	public function get_user_roles()
	{
		return $this->config->config['user_role'];
	}

	public function get_users($select='', $options=array())
	{
		$select	= empty($select) ? 'eu.user_id, eu.first_name, eu.last_name, eu.email, eu.user_role, eu.hourly_rate, eu.user_image, eu.department, eu.time_zone_code, eu.is_active, sum(t.hours) AS hours' : $select;

		$query	= $this->users_list_query($select, $options);
		$return = $query->result_array();

		if ($return && strpos($select,'user_role')!==false)
		{
			foreach ($return as $key => $row)
			{
				$row['is_edit_permission'] = true;				
				$return[$key]	= $row;
			}
		}

		return $return;
	}

	public function get_user($user_id = 0)
	{
		$user_id = intval($user_id);

		if ($user_id <= 0)
		{
			$this->error	= 'INVALID_REQUEST';
			return false;
		}

		$this->db->select('user_id, first_name, last_name, email, user_role, hourly_rate, user_image, department, time_zone_code, is_active');
		$this->db->from('entity_users');
		$this->db->where(array('entity_id'=> $this->ot_app->get('entity_id'), 'user_id' => $user_id));

		$query = $this->db->get();

		$data = $query->row_array();

		return $data;
	}
		
	public function have_add_permission()
	{
		return true;
	}

	public function delete($user_id)
	{
		$user_id = intval($user_id);

		if ($user_id <= 0 && $user_id==$this->ot_user->get('user_id'))
		{
			return false;
		}

		// delete user detail
		$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'user_id' => $user_id));
		$this->db->delete('entity_users');

		//delete user activity detail
		$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'user_id' => $user_id));
		$this->db->delete('user_activity');

		return true;
	}
/*
	public function activate($user_id, $active=true)
	{
		$user_id = intval($user_id);

		if ($user_id <= 0)
		{
			$this->error	= 'INVALID_REQUEST';
			return false;
		}
		
		$active = ($active) ? 1 : 0;
		$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'user_id' => $user_id));
		$this->db->update('entity_users', array('is_active'=>$active)); 
		
		return true;
	}
*/
	public function get_account_owner()
	{
		$entity_id = $this->ot_app->get('entity_id');
		
		$this->db->select('account_owner_id');
		$this->db->where(array('entity_id' => $entity_id));
		$query = $this->db->get('entity_setting');
		
		$result = $query->row_array();
		return (!empty($result['account_owner_id'])?$result['account_owner_id']:0);
	
	}

	public function get_projects($user_id = 0, $options = array())
	{
		if ($user_id <= 0)
		{
			$this->error	= 'INVALID_REQUEST';
			return false;
		}
		
		$this->db->select('pr.project_id, concat(pr.project_code, pr.project_name) AS project_name, pr.is_active, pr.created_date, pr.last_updated_date, concat(cl.client_code, cl.client_name) AS client_name, sum(ts.hours) as hours, max(ts.last_updated_date) as date', false);
		$this->db->from('project as pr');
		$this->db->join('project_users as pru', 'pr.entity_id=pru.entity_id and pr.project_id=pru.project_id', 'INNER');
		$this->db->join('client as cl', 'pr.entity_id=cl.entity_id and pr.client_id=cl.client_id', 'INNER');
		$this->db->join('time_sheet as ts', 'pr.entity_id=ts.entity_id and pr.project_id=ts.project_id AND ts.user_id = '.$user_id.'', 'LEFT OUTER');
		$this->db->where(array('pr.entity_id' => $this->ot_app->get('entity_id'), 'pru.user_id' => $user_id));
		$this->db->group_by('pr.project_id');
		$this->db->order_by('date', 'desc');
	
		$from	= empty($options['from']) ? 0 : $options['from'];
		if (!empty($options['count']))
		{
			$this->db->limit($options['count'], $from);
		}
	
		$query = $this->db->get();
	
		$data = $query->result_array();
	
		return $data;
	}
}
